> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Ranger service-def slice (resource keys + access types)



## OpenAPI

````yaml get /api/govern/data-access/metadata/service-def
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/govern/data-access/metadata/service-def:
    get:
      tags:
        - Policy Management
      summary: Ranger service-def slice (resource keys + access types)
      operationId: get_service_def_metadata_api_govern_data_access_metadata_service_def_get
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ServiceDefMetadataResponse'
        '502':
          description: Bad Gateway
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '503':
          description: Service Unavailable
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    ServiceDefMetadataResponse:
      properties:
        resources:
          items:
            $ref: '#/components/schemas/ResourceDefMetadata'
          type: array
          title: Resources
        accessTypes:
          items:
            type: string
          type: array
          title: Accesstypes
        maskTypes:
          items:
            $ref: '#/components/schemas/MaskTypeMetadata'
          type: array
          title: Masktypes
      type: object
      title: ServiceDefMetadataResponse
      description: Ranger service-def slice needed to populate the policy form.
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    ResourceDefMetadata:
      properties:
        name:
          type: string
          title: Name
        recursiveSupported:
          type: boolean
          title: Recursivesupported
          default: false
        excludesSupported:
          type: boolean
          title: Excludessupported
          default: false
        mandatory:
          type: boolean
          title: Mandatory
          default: false
        lookupSupported:
          type: boolean
          title: Lookupsupported
          default: false
        parent:
          anyOf:
            - type: string
            - type: 'null'
          title: Parent
        level:
          type: integer
          title: Level
          default: 0
      type: object
      required:
        - name
      title: ResourceDefMetadata
      description: Per-resource flags the drawer needs to pick the right affordances.
    MaskTypeMetadata:
      properties:
        name:
          type: string
          title: Name
        label:
          type: string
          title: Label
        description:
          type: string
          title: Description
          default: ''
      type: object
      required:
        - name
        - label
      title: MaskTypeMetadata
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````